<?php

namespace CustomerManagement\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDeviceSignalInfo ArrayType
 * @subpackage Arrays
 */
class ArrayOfDeviceSignalInfo extends AbstractStructArrayBase
{
    /**
     * The DeviceSignalInfo
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \CustomerManagement\StructType\DeviceSignalInfo[]
     */
    public $DeviceSignalInfo;
    /**
     * Constructor method for ArrayOfDeviceSignalInfo
     * @uses ArrayOfDeviceSignalInfo::setDeviceSignalInfo()
     * @param \CustomerManagement\StructType\DeviceSignalInfo[] $deviceSignalInfo
     */
    public function __construct(array $deviceSignalInfo = array())
    {
        $this
            ->setDeviceSignalInfo($deviceSignalInfo);
    }
    /**
     * Get DeviceSignalInfo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \CustomerManagement\StructType\DeviceSignalInfo[]|null
     */
    public function getDeviceSignalInfo()
    {
        return isset($this->DeviceSignalInfo) ? $this->DeviceSignalInfo : null;
    }
    /**
     * This method is responsible for validating the values passed to the setDeviceSignalInfo method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDeviceSignalInfo method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDeviceSignalInfoForArrayConstraintsFromSetDeviceSignalInfo(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfDeviceSignalInfoDeviceSignalInfoItem) {
            // validation for constraint: itemType
            if (!$arrayOfDeviceSignalInfoDeviceSignalInfoItem instanceof \CustomerManagement\StructType\DeviceSignalInfo) {
                $invalidValues[] = is_object($arrayOfDeviceSignalInfoDeviceSignalInfoItem) ? get_class($arrayOfDeviceSignalInfoDeviceSignalInfoItem) : sprintf('%s(%s)', gettype($arrayOfDeviceSignalInfoDeviceSignalInfoItem), var_export($arrayOfDeviceSignalInfoDeviceSignalInfoItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The DeviceSignalInfo property can only contain items of type \CustomerManagement\StructType\DeviceSignalInfo, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DeviceSignalInfo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \CustomerManagement\StructType\DeviceSignalInfo[] $deviceSignalInfo
     * @return \CustomerManagement\ArrayType\ArrayOfDeviceSignalInfo
     */
    public function setDeviceSignalInfo(array $deviceSignalInfo = array())
    {
        // validation for constraint: array
        if ('' !== ($deviceSignalInfoArrayErrorMessage = self::validateDeviceSignalInfoForArrayConstraintsFromSetDeviceSignalInfo($deviceSignalInfo))) {
            throw new \InvalidArgumentException($deviceSignalInfoArrayErrorMessage, __LINE__);
        }
        if (is_null($deviceSignalInfo) || (is_array($deviceSignalInfo) && empty($deviceSignalInfo))) {
            unset($this->DeviceSignalInfo);
        } else {
            $this->DeviceSignalInfo = $deviceSignalInfo;
        }
        return $this;
    }
    /**
     * Add item to DeviceSignalInfo value
     * @throws \InvalidArgumentException
     * @param \CustomerManagement\StructType\DeviceSignalInfo $item
     * @return \CustomerManagement\ArrayType\ArrayOfDeviceSignalInfo
     */
    public function addToDeviceSignalInfo(\CustomerManagement\StructType\DeviceSignalInfo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \CustomerManagement\StructType\DeviceSignalInfo) {
            throw new \InvalidArgumentException(sprintf('The DeviceSignalInfo property can only contain items of type \CustomerManagement\StructType\DeviceSignalInfo, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->DeviceSignalInfo[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \CustomerManagement\StructType\DeviceSignalInfo|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \CustomerManagement\StructType\DeviceSignalInfo|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \CustomerManagement\StructType\DeviceSignalInfo|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \CustomerManagement\StructType\DeviceSignalInfo|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \CustomerManagement\StructType\DeviceSignalInfo|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DeviceSignalInfo
     */
    public function getAttributeName()
    {
        return 'DeviceSignalInfo';
    }
}
